<script>
import { chartMixin } from '@/mixins/chart'

export default {
  mixins: [chartMixin],
  props: {
    rows: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      eventsCharts: [
        'milestoneBarChart',
        'tierBarChart',
        'productCategoriesChart',
      ],
      milestoneBarChart: null,
      tierBarChart: null,
      productCategoriesChart: null,
      resizeHandler: null,
    }
  },
  watch: {
    rows: {
      handler(newRows) {
        if (newRows.length > 0) {
          this.initializeCharts(this.eventsCharts, '/events')
          this.resizeHandler = () => this.resizeCharts(this.eventsCharts)
          window.addEventListener('resize', this.resizeHandler)
        }
      },
      immediate: false,
    },
  },
  mounted() {
    if (this.rows?.length > 0) {
      this.initializeCharts(this.eventsCharts, '/events')
      this.resizeHandler = () => this.resizeCharts(this.eventsCharts)
      window.addEventListener('resize', this.resizeHandler)
    }
  },
  beforeDestroy() {
    if (this.resizeHandler) {
      window.removeEventListener('resize', this.resizeHandler)
    }
    this.disposeCharts(this.eventsCharts)
  },
  methods: {
    updateCharts() {
      this.updateMileStoneChart()
      this.updateTierChart()
      this.updateProductCategoriesChart()
    },
  },
}
</script>

<template>
  <div>
    <div class="flex-container side-by-side-charts">
      <div class="flex-item">
        <h2>Milestone Distribution</h2>
        <div ref="milestoneBarChart" class="chart-container"></div>
      </div>
      <div class="flex-item">
        <h2>Tier Distribution</h2>
        <div ref="tierBarChart" class="chart-container"></div>
      </div>
    </div>

    <div class="flex-item">
      <h2>Product Category Distribution</h2>
      <div ref="productCategoriesChart" class="chart-container"></div>
    </div>
  </div>
</template>

<style scoped src="../assets/styles/charts.css"></style>
